
import sys
from random import *
from PyQt5.QtWidgets import QApplication, QWidget, QLabel, QPushButton,QComboBox

class QtGUI(QWidget):

    def __init__(self):
        super().__init__()
        self.setWindowTitle("Lotto Number Generator")
        self.resize(360, 400)
        self.intialL1 = 'Recommend Lotto Number'

        # 추천 숫자 표시
        self.intialL2 = 'None, None, None, None, None, None'

        # 사전 선택된 번호가 저장될 리스트
        self.selected_num= []
        self.limit = 0

        #숫자 버튼에 사용될 부분
        self.index = 1
        self.but_list=[]

        label1 = QLabel(self.intialL1 , self)
        label1.move(10,10)

        label2 = QLabel(self.intialL2, self)
        label2.move(10, 50)

        label3 = QLabel("selected : ", self)
        label3.move(240, 355)

        QCB = QComboBox(self)
        QCB.addItem("0")
        QCB.addItem("1")
        QCB.addItem("2")
        QCB.addItem("3")
        QCB.addItem("4")
        QCB.addItem("5")
        QCB.move(300, 350)
        QCB.activated[str].connect(lambda: self.select_limit(QCB))


        # 숫자 버튼 생성
        for i in range(1,46):
            self.make_button_num(self.index)
            self.index = self.index+ 1

        # 로또 번호 생성 버튼 생성
        button = QPushButton('Generate', self)

        button.move(20, 350)

        button.clicked.connect(lambda: self.print_label(label2))

        # 선택 번호 초기화

        button1 = QPushButton('refresh', self)

        button1.move(100, 350)

        button1.clicked.connect(self.refresh_but)

        self.show()

    def Make_Number(self):
        Number = []
        Number.extend(self.selected_num)

        while len(Number) < 6:
            v=randint(1, 45)
            if v not in Number :
                Number.append(v)

        return Number

    def make_button_num(self, index):
        button = QPushButton(str(index), self)
        button.resize(30,30)
        w = 0
        v = 0
        if index < 11 :
            w = 100
            v = index
        elif index < 21 :
            w = 150
            v = index - 10
        elif index < 31 :
            w = 200
            v = index - 20
        elif index < 41 :
            w = 250
            v = index - 30
        else :
            w = 300
            v = index - 40

        button.move(v*30,w )
        self.but_list.append(button)
        button.clicked.connect(lambda :self.inputnum(button))

    def select_limit(self,QCB):
        self.refresh_but()
        self.limit = int(QCB.currentText())

    def print_label(self,label):
        Number = self.Make_Number()
        Number.sort()
        label.setText(str(Number))

    def inputnum(self,button):
        if len(self.selected_num) < self.limit:
            self.selected_num.append(int(button.text()))
            button.setEnabled(False)

    def refresh_but(self):
        self.selected_num =[]
        self.limit = 0
        for i in self.but_list:
            i.setEnabled(True)


if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = QtGUI()
    app.exec_()
